/*****************************************************************************************
 Copyright (c) 2002-2004 The UbixOS Project
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are
 permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright notice, this list of
 conditions, the following disclaimer and the list of authors.  Redistributions in binary
 form must reproduce the above copyright notice, this list of conditions, the following
 disclaimer and the list of authors in the documentation and/or other materials provided
 with the distribution. Neither the name of the UbixOS Project nor the names of its
 contributors may be used to endorse or promote products derived from this software
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id$

*****************************************************************************************/

#ifndef _PAGING_H
#define _PAGING_H

#include <ubixos/types.h>

#define pageLength        0x00000400
#define pageSize          4096
#define pageEntries       (pageSize/4)
#define pagePresent       0x00000001
#define pageWrite         0x00000002
#define pageUser          0x00000004
#define pageCow           0x00000200
#define pageStack         0x00000400
#define pageDefault       (pagePresent|pageWrite|pageUser)
#define kernelPageDefault (pagePresent|pageWrite)
#define tablesBaseAddress 0xBFC00000
#define parentPageDirAddr 0x100000

int vmmPagingInit();
int vmmClearVirtualPage(uInt32 pageAddr);
int vmmRemapPage(uInt32,uInt32);
void vmmUnmapPage(uInt32,int);
void vmmUnmapPages(void *,uInt32);
void vmmSetPageAttribute(uInt32,int);
void *vmmMapFromTask(pidType,void *,uInt32);
void *vmmCopyVirtualSpace(pidType);
void *vmmGetFreePage(pidType);
void *vmmGetFreeKernelPage(pidType pid,uInt16 count);
void *vmmGetPhysicalAddr(uInt32);
void *vmmCreateVirtualSpace(pidType);
void *vmmGetFreeVirtualPage(pidType,int);
void vmmPageFault();
void _vmmPageFault();

extern uInt32 *kernelPageDirectory;

#endif

/***
 $Log$
 Revision 1.2  2004/05/21 15:21:04  reddawg
 Cleaned up


 END
 ***/
